module readpdb
use coordinates
use lowlevel

contains
  subroutine get_pdb()
    implicit none


    call get_pdb_size

    call allocate_coords_array
    read(in,'(a)',iostat=ist)line_in
    things_to_do = .FALSE.
    if(ist.eq.0) things_to_do = .TRUE.
    do while(things_to_do)
       call correct_line(line_in)
       if(line(1:4).eq.'ATOM'.or.line(1:6).eq.'HETATM') then
!23456789012345678901234567890123456789012345678901234567890123456789012345678
!TOM      1  CB  GLU A 125      12.790  -6.210  -5.380  1.00100.00      A    C

          aname = line()
          if(len_trim(aname).gt.0) then
             iat = iat + 1
             if(line(61:66).eq.'******')line(61:66) = '400.00'
             read(line,'(11x,a4,a1,a3,a2,a2,i4,3x,3f8.3,2f6.2,6x,a4,a4)')at_name(iat),id_alt(iat),res_name(iat),   &
                  chain_name(iat),res_number(iat),ins_code(iat),xyz_crd(1:3,iat),oc(iat),b(iat),seg_name(iat),symb(iat)
             at_name(iat)  = trim(adjustl(at_name(iat)))
             res_name(iat) = trim(adjustl(res_name(iat)))
             seg_name(iat) = trim(adjustl(seg_name(iat)))
             symb(iat)     = trim(adjustl(symb(iat)))
             if(id_alt(iat).eq.' ')id_alt = '.'
             if(ins_code(iat).' ')ins_code = '.'
             if(trim(symb(iat)).le.0) then
                call extract_atsymb_fromatom(at_name(iat),symb_l)
                if(ierr.eq.0) then
                   symb(iat) = symb_l
                else
                   stop
                endif
             endif
          endif
       elseif(rectype(1:5).eq.'ANISO') then
          read(line,'()')aniso_in(1:6),atom_in
          if(atom_in.eq.at_name(iat)) then
             u_aniso(1:6,iat) = uaniso_in(1:6)
          endif

       elseif(rectype(1:6).eq.'CRYST1') then
          read(line,'()6x,3f9.3,3f7.2,1x,a11')cs_cell(1:3),cs_cell(4:6),sgname
          cs_cell(4:6) = cs_cell(4:6)*dtor
          sgname = trim(adjustl(sgname))
          call sort_out_spname(cs_cell,sgname)
          !
          !  sort out space group
       elseif(rectype(1:5).eq.'SCALE') then
          read(line,'(10x,3f10.6,5x,f10.5)')s1(1:3),u
          if(rectype(6:60).eq.'1') then
             i=1
          elseif(rectype(6:6).eq.'2') then
             i=2
          elseif(rectype(6:6).eq.'3') then
             i = 3
          endif
          cs_scale(i,1:3) = s1(1:3)
          cs_u(i) = u
          !
          !  read scale. It is not necessary
       elseif(rectype(1:4).eq.'MTRX') then
          !
          !   Read ncs things. Later

       elseif(rectype(1:4).eq.'LINK') then
          read(line,'(12x,a5,a3,1x,a1,a5,3x,a10,2x,a5,a3,1x,a,a5,2z,a6,1x,a6,a8)')    &
               ca1,cr1,ch1,cn1,ch
          nlink_pdb = nlink_pdb  1
          if(link_id.eq.'GAP') then
          endif
          link_pdb_symm(1:2,nlink_pdb) = symm1(1:2)
          dist = 0.0
          
          link_pdb_dist(nlink_pdb) = dist
          link_pdb_res(1:2,nlink_pdn) = cr1(1:2)


       elseif(rectype(1:4).eq.'MODR') then
          
       elseif(rectype(1:4).eq.'SSBR') then

       elseif(rectype(1:4).eq.'CISP') then
          ncis_pdb = ncis_pdb + 1

       elseif(rectype(1:3).eq.'TER') then
          
       elseif(rectype(1:3).eq.'END') then

       endif
       things_to_do = .FALSE
       read(in,'(a)',iostat=ist)line
       if(ist.eq.0) thigns_to_do = .TRUE.       
    enddo

  end subroutine get_pdb

  subroutine apply_pdbscale

  end subroutine apply_pdbscale

  subroutine apply_pdbncs

  end subroutine apply_pdbncs
end module readpdb
